scala.tools.nsc.backend.opt.DeadCodeElimination

# DeadCode

#### class DeadCode extends AnyRef

Remove dead code.

Source
  DeadCodeElimination.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. DeadCode
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new DeadCode()

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from DeadCode to any2stringadd[DeadCode] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (DeadCode, B)

   Implicit information
     This member is added by an implicit conversion from DeadCode to ArrowAssoc[DeadCode] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### var accessedLocals: List[Global.icodes.Local]

   what local variables have been accessed at least once?

7. #### def analyzeClass(cls: Global.icodes.IClass): Unit

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### val clobbers: Set[(Global.icodes.BasicBlock, Int)]

   Stores that clobber previous stores to array or ref locals.

   Stores that clobber previous stores to array or ref locals. See SI-5313

10. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

11. #### def collectRDef(m: Global.icodes.IMethod): Unit

    collect reaching definitions and initial useful instructions for this method.

12. #### var defs: Map[InstrLoc, Set[Definition]]

    Use-def chain: give the reaching definitions at the beginning of given instruction.

13. #### def dieCodeDie(m: Global.icodes.IMethod): Unit

14. #### val dropOf: Map[InstrLoc, List[InstrLoc]]

    Map instructions who have a drop on some control path, to that DROP instruction.

15. #### def ensuring(cond: (DeadCode) ⇒ Boolean, msg: ⇒ Any): DeadCode

    Implicit information
      This member is added by an implicit conversion from DeadCode to Ensuring[DeadCode] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (DeadCode) ⇒ Boolean): DeadCode

    Implicit information
      This member is added by an implicit conversion from DeadCode to Ensuring[DeadCode] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): DeadCode

    Implicit information
      This member is added by an implicit conversion from DeadCode to Ensuring[DeadCode] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): DeadCode

    Implicit information
      This member is added by an implicit conversion from DeadCode to Ensuring[DeadCode] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

20. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

21. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

22. #### def findClobbers(l: Global.icodes.Local, bb: Global.icodes.BasicBlock, idx: Int): Unit

    Finds and marks all clobbers of the given local starting in the given basic block at the given index

    Finds and marks all clobbers of the given local starting in the given basic block at the given index

    Storing to local variables of reference or array type may be indirectly observable because it may remove a reference to an object which may allow the object to be gc'd. See SI-5313. In this code I call the LOCAL_STORE(s) that immediately follow a LOCAL_STORE and that store to the same local "clobbers." If a LOCAL_STORE is marked useful then its clobbers must go into the set of clobbers, which will be compensated for later

23. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from DeadCode to StringFormat[DeadCode] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

24. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

25. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

26. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

27. #### val localStores: Map[(Global.icodes.Local, Global.icodes.BasicBlock), BitSet]

    Map from a local and a basic block to the instructions that store to that local in that basic block

28. #### def mark(): Unit

    Mark useful instructions.

    Mark useful instructions. Instructions in the worklist are each inspected and their dependencies are marked useful too, and added to the worklist.

29. #### var method: Global.icodes.IMethod

    the current method.

30. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

31. #### final def notify(): Unit

    Definition Classes
      AnyRef

32. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

33. #### val rdef: icode.ICodes.reachingDefinitions.ReachingDefinitionsAnalysis

34. #### def sweep(m: Global.icodes.IMethod): Unit

35. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

36. #### def toString(): String

    Definition Classes
      AnyRef → Any

37. #### val useful: Map[Global.icodes.BasicBlock, BitSet]

    what instructions have been marked as useful?

38. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### val worklist: Set[InstrLoc]

    Useful instructions which have not been scanned yet.

42. #### def →[B](y: B): (DeadCode, B)

    Implicit information
      This member is added by an implicit conversion from DeadCode to ArrowAssoc[DeadCode] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from DeadCode to any2stringadd[DeadCode]

### Inherited by implicit conversion StringFormat from DeadCode to StringFormat[DeadCode]

### Inherited by implicit conversion Ensuring from DeadCode to Ensuring[DeadCode]

### Inherited by implicit conversion ArrowAssoc from DeadCode to ArrowAssoc[DeadCode]

### Ungrouped